diff -Nru mt76-2020-01-04-8a785679/eeprom.c mt76-2020-01-04-8a785679-02-txpower-fix/eeprom.c
--- mt76-2020-01-04-8a785679/eeprom.c	2020-01-04 22:57:55.000000000 +0200
+++ mt76-2020-01-04-8a785679-02-txpower-fix/eeprom.c	2020-03-10 02:40:09.063933798 +0200
@@ -8,6 +8,7 @@
 #include <linux/mtd/partitions.h>
 #include <linux/etherdevice.h>
 #include "mt76.h"
+#include "mt76x02_eeprom.h"
 
 static int
 mt76_get_of_eeprom(struct mt76_dev *dev, int len)
@@ -85,6 +86,8 @@
 void
 mt76_eeprom_override(struct mt76_dev *dev)
 {
+	int i;
+	u8 *eep;
 #ifdef CONFIG_OF
 	struct device_node *np = dev->dev->of_node;
 	const u8 *mac = NULL;
@@ -101,6 +104,27 @@
 			 "Invalid MAC address, using random address %pM\n",
 			 dev->macaddr);
 	}
+	
+	eep = dev->eeprom.data;
+	/* Override maximum TxPower 0x28 == 40 in 0.5 steps or 20 dB per chain (total 23dB) */
+	eep[MT_EE_TX_POWER_0_START_2G + 2] = 0x28;
+	eep[MT_EE_TX_POWER_1_START_2G + 2] = 0x28;
+
+	/* Override TxPower in SKU byte of EEPROM. 0x36 = 54 or 27dB. */
+	eep[MT_EE_RF_2G_RX_HIGH_GAIN] = 0x36;
+	/* Override TxPower for each chain in 0.5dB step. */
+	for(i=0; i<=MT_TX_POWER_GROUPS_5G;i++){
+		/* Set txPower for each chain from SKU TxPower byte. */
+		eep[MT_EE_TX_POWER_0_START_5G + 2 + i * MT_TX_POWER_GROUP_SIZE_5G] = eep[MT_EE_RF_2G_RX_HIGH_GAIN];
+		eep[MT_EE_TX_POWER_1_START_5G + 2 + i * MT_TX_POWER_GROUP_SIZE_5G] = eep[MT_EE_RF_2G_RX_HIGH_GAIN];
+	}
+	/* We have to decrease power output on spreaded channels.
+	 * By standard we need to decrease it by 3dB for each doubled channel width.
+	 * Here we overriding EEPROM value with 1.5dB for each doubling width.
+	 */
+	eep[MT_EE_TX_POWER_DELTA_BW40] = 0x83;
+	eep[MT_EE_TX_POWER_DELTA_BW80] = 0x86;
+
 }
 EXPORT_SYMBOL_GPL(mt76_eeprom_override);
 
